// Set 09  Class Code
// Demo 1
// Motion control with mouse input

/*  You should look at this code while you are reading over the class notes bn10  
*/


// global variables
PFont f;

int diameter, diameterDelta;
int fasterButtonX, slowerButtonX;
int buttonY;
int buttonDiameter;

void setup( )
{
  size( 400, 400 );
  frameRate( 30 );
  smooth( );
  noStroke( );
  
  f = loadFont( "f.vlw");
  textFont( f, 28 );
   
  diameter = 5;
  diameterDelta = 0;
  
  fasterButtonX = int(width*.2 );
  slowerButtonX = int( width*.8);
  buttonY = int(height*.8);
  buttonDiameter = int( width*.2 );
}

void draw( )
{
  fill( 0, 0, 255 );
  rect( 0, 0, width, height );
  
  drawButtons( );
  changeCircle( );  // max percentage of the width
  drawCircle( );
  showStats( ); 
}

void showStats( )
{
   fill( 255, 255, 0 );
   textAlign( LEFT );
   text( "circle diameter: " + diameter, 20, 50 );
   text( "diameter delta: " + diameterDelta, 20, 100 ); 
}
void drawButtons( )
{
   fill( 0, 255, 0 );
   ellipse( fasterButtonX, buttonY,   buttonDiameter, buttonDiameter);
  
   fill( 255, 0, 0 );
   ellipse( slowerButtonX, buttonY,   buttonDiameter, buttonDiameter);
   
   fill( 0 );
   textAlign( CENTER );
   text( "faster", fasterButtonX, buttonY+8 );
   text( "slower", slowerButtonX, buttonY+8 );
   
}

void mousePressed( )
{
 if ( dist( mouseX, mouseY, fasterButtonX, buttonY) < buttonDiameter )
 {
     diameterDelta++;
 }
 else if ( dist( mouseX, mouseY, slowerButtonX, buttonY) < buttonDiameter )
 {
    diameterDelta--;
 }
 
}


void keyPressed ( )
{
  if (  key == ' ')
  {
     diameterDelta  = 0; 
     diameter = 5;
     
     println( "resetting diameterDelta to zero" );
  }
}

void changeCircle(  )
{
   diameter = diameter + diameterDelta;
   
}

void drawCircle( )
{
    if ( diameter < 0 )
    {
       fill( 255, 0, 0 );
    }
    else
    {
       fill( 0, 255, 0 ); 
    }
    ellipse( width/2, height/2, diameter, diameter ); 
}

